#ifdef HAVE_IO_H
#include <io.h>
#endif
#include <fcntl.h>
#include <stdio.h>
#ifdef HAVE_DOS_H
#include <dos.h>
#endif
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif
#include <string.h>
#include <stdarg.h>
#include <time.h>
#ifdef HAVE_DIR_H
#include <dir.h>
#endif
#ifdef HAVE_SYSLOG_H
#include <syslog.h>
#endif
#include <stdlib.h>
#include <fidolib.h>
#include "gate.h"

char logname[256]="";
char copyright[256]="";
char loglevel[32]="-$~`&^@=>%#!?*";
logtype logstyle = FD_LOG;

void cdecl logwrite(char level,char * format,...)
{ va_list arg;
  int flog;
  static int firstlog=1;
  static char slog[2048];
  time_t curtime;
  struct tm * curtm;
  char *p;

  curtime=time(NULL);
  curtm=localtime(&curtime);
  if (firstlog)
  { firstlog=0;
    if (logstyle == FD_LOG)
      logwrite('*',"\n-----------  %s %u %s %02u,  %s\n",
        weekday[curtm->tm_wday], curtm->tm_mday, 
        montable[curtm->tm_mon], curtm->tm_year+1900, copyright);
#ifdef HAVE_SYSLOG_H
    else if (logstyle == SYSLOG_LOG)
    { openlog("ATTU", LOG_PID, LOG_USER);
      logname[0]='\0';
      flog=1;
    }
#endif
  }
  va_start(arg,format);
  slog[0]='\0';
  if (logname[0])
  {
    if (access(logname,0))
      flog=myopen(logname,O_TEXT|O_RDWR|O_CREAT);
    else
      flog=myopen(logname,O_TEXT|O_RDWR|O_APPEND);
    if (flog==-1)
    { fputs("Can't write to log:\n",stderr);
      vfprintf(stderr,format,arg);
      va_end(arg);
      debug(0, "Can't write to log:");
      vsprintf(slog,format,arg);
      debug(0, slog);
      return;
    }
    if (level!='*')
    { if (logstyle == FD_LOG)
        sprintf(slog,"%c  %02u:%02u:%02u  ",level,
                curtm->tm_hour,curtm->tm_min,curtm->tm_sec);
      else
        sprintf(slog,"%c %2d %s %02u:%02u:%02u ATTU ",level,
                curtm->tm_mday, montable[curtm->tm_mon],
                curtm->tm_hour,curtm->tm_min,curtm->tm_sec);
    }
  }
  else
    flog=-1;
  p=slog+strlen(slog);
#ifdef HAVE_SNPRINTF
  vsnprintf(p, sizeof(slog)-(p-slog),
#else
  vsprintf(p,
#endif
            format,arg);
  if (flog!=-1)
  {
#ifdef HAVE_SYSLOG_H
    if (logstyle==SYSLOG_LOG)
    { int syslog_level;
      switch (level)
      { case '?': syslog_level=LOG_ERR;     break;
        case '!': syslog_level=LOG_WARNING; break;
        case '$': syslog_level=LOG_NOTICE;  break;
        default:  syslog_level=LOG_INFO;    break;
      }
      syslog(syslog_level, "%s", slog);
    }
    else
#endif
    { write(flog,slog,strlen(slog));
      close(flog);
    }
  }
  va_end(arg);
  if (level!='*')
  { if (((level!='?') && (!quiet) && (debuglevel<2)) ||
        ((level=='?') && (debuglevel<0)))
      fputs(p,stderr);
    debug((level=='?') ? 0 : 2, "%s", p);
  }
}
