CC = wcc386
LINK = wcl386
DEFINES = -DHAVE_IO_H -DHAVE_DIRECT_H -DHAVE_DOS_H -DHAVE_MALLOC_H \
          -DHAVE_PROCESS_H -DHAVE_SHARE_H -DHAVE_SYS_UTIME_H -DHAVE_PROCESS_H \
          -DHAVE_CWAIT
COPT = /w3 /fo=$@ $(DEFINES)
LOPT = /x

!ifdef DEBUG
CFLAGS = $(COPT) /d2 /hw
LFLAGS = $(LOPT) /d2 /hw
OBJDIR = obj2\debug
!else
CFLAGS = $(COPT)
LFLAGS = $(LOPT)
OBJDIR = obj2
!endif

.c.obj:
  $(CC) $(CFLAGS) $<

.asm.obj:
  wasm $<

OBJ = \
 $(OBJDIR)\attach.obj \
 $(OBJDIR)\checktmp.obj \
 $(OBJDIR)\config.obj \
 $(OBJDIR)\uuencode.obj \
 $(OBJDIR)\uudecode.obj \
 $(OBJDIR)\from.obj \
 $(OBJDIR)\misc.obj \
 $(OBJDIR)\do_uuen.obj \
 $(OBJDIR)\do_uude.obj \
 $(OBJDIR)\do_b64.obj \
 $(OBJDIR)\do_unb64.obj \
 $(OBJDIR)\logwrite.obj \
 $(OBJDIR)\crc.obj \
 $(OBJDIR)\ea.obj \
 $(OBJDIR)\myfopen.obj \
 $(OBJDIR)\template.obj \
 $(OBJDIR)\gettz.obj \
 $(OBJDIR)\debug.obj \
 $(OBJDIR)\savein.obj \
 $(OBJDIR)\swap2.obj \
 $(OBJDIR)\cmpaddr.obj \
 $(OBJDIR)\basename.obj \
 $(OBJDIR)\regex.obj

all: $(OBJDIR)\attuucp2.exe $(OBJDIR)\attuucp.exe

$(OBJDIR)\attach.obj:   attach.c gate.h
$(OBJDIR)\config.obj:   config.c gate.h exec.h
$(OBJDIR)\from.obj:     from.c gate.h
$(OBJDIR)\misc.obj:     misc.c gate.h
$(OBJDIR)\uuencode.obj: uuencode.c gate.h exec.h
$(OBJDIR)\uudecode.obj: uudecode.c gate.h exec.h
$(OBJDIR)\checktmp.obj: checktmp.c
$(OBJDIR)\do_uuen.obj:  do_uuen.c  gate.h
$(OBJDIR)\do_uude.obj:  do_uude.c  gate.h
$(OBJDIR)\do_b64.obj:   do_b64.c   gate.h
$(OBJDIR)\do_unb64.obj: do_unb64.c gate.h
$(OBJDIR)\logwrite.obj: logwrite.c gate.h
$(OBJDIR)\crc.obj:      crc.c
$(OBJDIR)\ea.obj:       ..\\lib\\ea.c
  $(CC) $(CFLAGS) ..\lib\ea
$(OBJDIR)\myfopen.obj:  ..\\lib\\myfopen.c
  $(CC) $(CFLAGS) ..\lib\myfopen
$(OBJDIR)\template.obj: ..\\lib\\template.c
  $(CC) $(CFLAGS) -DATTUUCP ..\lib\template
$(OBJDIR)\gettz.obj:  ..\\lib\\gettz.c
  $(CC) $(CFLAGS) ..\lib\gettz
$(OBJDIR)\debug.obj:  ..\\lib\\debug.c
  $(CC) $(CFLAGS) -DATTUUCP ..\lib\debug
$(OBJDIR)\savein.obj: ..\\lib\\savein.c
  $(CC) $(CFLAGS) ..\lib\savein
$(OBJDIR)\swap2.obj:  ..\\lib\\swap2.c
  $(CC) $(CFLAGS) ..\lib\swap2
$(OBJDIR)\cmpaddr.obj:  ..\\lib\\cmpaddr.c
  $(CC) $(CFLAGS) ..\lib\cmpaddr
$(OBJDIR)\basename.obj:  ..\\lib\\basename.c
  $(CC) $(CFLAGS) ..\lib\basename
$(OBJDIR)\regex.obj:  ..\\lib\\regex.c
  $(CC) $(CFLAGS) -DHAVE_STRING_H=1 -DREGEX_MALLOC -DHAVE_LIBINTL_H=0 ..\lib\regex

$(OBJDIR)\attuucp.exe: attuucp.dos $(OBJ)
  $(LINK) /"Option stub=attuucp.dos" /fe=$(OBJDIR)\attuucp.exe $(LFLAGS) $(OBJ) ..\fidolib\flibp.lib

$(OBJDIR)\attuucp2.exe: $(OBJ)
  $(LINK) /fe=$(OBJDIR)\attuucp2.exe $(LFLAGS) $(OBJ) flibp.lib

clean: .SYMBOLIC
  del $(OBJDIR)\*.obj
