#ifdef HAVE_IO_H
#include <io.h>
#endif
#ifdef HAVE_DOS_H
#include <dos.h>
#endif
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif
#include <fcntl.h>
#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <time.h>
#include "fidolib.h"

char logname[256]="";
char copyright[256]="";
char loglevel[32]="-$~`&^@=>%#!?";

void cdecl logwrite(char level,char * format,...)
{ va_list arg;
  int  flog;
  char *p;
  static int firstlog=1;
  time_t curtime;
  struct tm *curtm;
  static char slog[512];

  if (logname[0]==0)
    return;
  if (level!='*')
    if (strchr(loglevel,level)==NULL)
      return;
  curtime=time(NULL);
  curtm=localtime(&curtime);
  if (firstlog)
  { firstlog=0;
    logwrite('*',"\n-----------  %s %u %s %02u,  %s\n",
      weekday[curtm->tm_wday],
      curtm->tm_mday,montable[curtm->tm_mon],curtm->tm_year%100, copyright);
  }
  va_start(arg,format);
  if (access(logname,0))
    flog=myopen(logname,O_TEXT|O_RDWR|O_CREAT);
  else
    flog=myopen(logname,O_TEXT|O_RDWR|O_APPEND);
  if (flog==-1)
  { fputs("Can't write to log:\n",stderr);
    vfprintf(stderr,format,arg);
    va_end(arg);
    return;
  }
  if (level!='*')
  { sprintf(slog,"%c  %02u:%02u:%02u  ",level,
             curtm->tm_hour,curtm->tm_min,curtm->tm_sec);
    p=slog+strlen(slog);
  }
  else
    p=slog;
#ifdef __EMX__
  vsnprintf(p, sizeof(slog)-(p-slog),
#else
  vsprintf(p,
#endif
           format,arg);
  write(flog,slog,strlen(slog));
  if (level=='?')
    fputs(p,stderr);
  close(flog);
  va_end(arg);
}
