#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#ifdef HAVE_IO_H
#include <io.h>
#endif
#include <fcntl.h>
#ifdef HAVE_DOS_H
#include <dos.h>
#endif
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif
#include <errno.h>
#include <stdlib.h>
#include <time.h>
#ifdef ATTUUCP
#include <fidolib.h>
#ifdef __MSDOS__
#define weekday  _weekday
#define montable _montable
#endif
#endif
#include "gate.h"

int  debuglevel=-1;
int  debuglog=0;

void cdecl debug(int level,char * format,...)
{ va_list arg;
  FILE *flog=NULL;
  static char debugname[FNAME_MAX]="";
  int  first=0;
  time_t curtime;
  struct tm * curtm;

  if (level>debuglevel) return;
  va_start(arg,format);
  if (debuglog)
  {
    if (debugname[0]=='\0')
#ifdef UNIX
      strcpy(debugname, "/var/log/lgatedbg.log");
#else
    { char *p;
      strcpy(debugname, myname);
      p=strrchr(debugname, '\\');
      if (p && strchr(p, '/')) p=strrchr(p, '/');
      if (p) p[1]='\0';
      else debugname[0]='\0';
      strcat(debugname, "lgatedbg.log");
      first=1;
    }
#endif
    flog=fopen(debugname,"a");
    if (flog==NULL)
    { flog=fopen(debugname,"w");
      if (flog==NULL)
      { fprintf(stderr, "Can't write to debug.log: %s\n",strerror(errno));
        debuglog=0;
      }
    }
    if (first)
    { curtime=time(NULL);
      curtm=localtime(&curtime);
      fprintf(flog,"\n>>> " NAZVA " started, debug level %d, %s %u %s %02u %02u:%02u:%02u\n",
              debuglevel, weekday[curtm->tm_wday],
              curtm->tm_mday, montable[curtm->tm_mon],
              curtm->tm_year%100,
              curtm->tm_hour, curtm->tm_min, curtm->tm_sec);
    }
    fprintf(flog, "(%d) ", level);
    vfprintf(flog,format,arg);
    if (format[strlen(format)-1]!='\n') fputs("\n", flog); /* no snprintf :-( */
    fclose(flog);
    va_end(arg);
    va_start(arg,format);
  }
  vfprintf(stderr,format,arg);
  if (format[strlen(format)-1]!='\n') fputs("\n", stderr); /* no snprintf :-( */
  va_end(arg);
}
