#ifndef __DIRENT_DEF_
#define __DIRENT_DEF_
#include <io.h> /* struct ftime */
#include <time.h>

#define MAXNAMLEN   13

struct dirent {
   long  d_size;
   short d_reclen;
   short d_namlen;
   time_t d_mtime;
   char  d_name[MAXNAMLEN];
};

typedef struct {
   char filereserved[21];
   char fileattr;
   struct ftime filetime;
   long filesize;
   char filename[MAXNAMLEN];
} DTA;

typedef struct {
   char dirid[4];
   struct dirent dirent;
   DTA dirdta;
   int dirfirst;
} DIR;

struct dirent * cdecl readdir(DIR *dirp);
void cdecl closedir(DIR *dirp);
DIR * cdecl opendir(const char *dirname);
#endif
